<?php
/*
Plugin Name: Whos Amung Stats
Plugin URI: http://linkloco.net
Description: Show statistics for you Whos Amung ID.
Version: 0.8
Author: Felipe Valtl de Mello
Author URI: http://linkloco.net/novo/author/admin/
License: GPL2
This Plugin uses PressTrends for analytics.
*/
load_plugin_textdomain( 'wp-whos-amung', '', dirname( plugin_basename( __FILE__ ) ) . '/lang' );
/*
	Plugin Developer tracking: Start!
 */
class MetricsTracker {
    public $token;
    public $host = 'http://api.mixpanel.com/';
    public function __construct($token_string) {
        $this->token = $token_string;
    }
    function track($event, $properties=array()) {
        $params = array(
            'event' => $event,
            'properties' => $properties
            );

        if (!isset($params['properties']['token'])){
            $params['properties']['token'] = $this->token;
        }
        $url = $this->host . 'track/?data=' . base64_encode(json_encode($params));
        //you still need to run as a background process
        //exec("curl '" . $url . "' >/dev/null 2>&1 &");
		$ch = curl_init($url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_exec($ch);
		curl_close($ch);
    }
}
function on_activate() {
	$metrics = new MetricsTracker("385ba1e60c224f394be3c7484972a352");
	$metrics->track('on_activate', array('ip'=>$_SERVER['REMOTE_ADDR'])
    );
}
function on_deactivate() {
	$metrics = new MetricsTracker("d4897a4111447421d1b4aa7671205ef9");
	$metrics->track('on_deactivate', array('ip'=>$_SERVER['REMOTE_ADDR'])
    );
	
}
function on_uninstall() {
	$metrics = new MetricsTracker("d4897a4111447421d1b4aa7671205ef9");
	$metrics->track('on_uninstall', array('ip'=>$_SERVER['REMOTE_ADDR'])
    );
}

register_activation_hook( __FILE__, 'on_activate');
register_deactivation_hook( __FILE__, 'on_deactivate');
register_uninstall_hook( __FILE__, 'on_uninstall');
/*
	Plugin Developer tracking: End!
 */
function wp_codex_search_form() {
global $wp_admin_bar, $wpdb;
if ( !is_super_admin() || !is_admin_bar_showing() )
return;
$url = 'http://whos.amung.us/sitecount/'. get_option('whosamung_id') .'/';
$x = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__));

/* Add the main siteadmin menu item */
if (get_option('whosamung_method')=="cURL"){
	function url2($Url) {
		if (!function_exists('curl_init')){ 
			die('CURL is not installed!');
		}
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $Url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$output = curl_exec($ch);
		curl_close($ch);
		return $output;
	}
}
if (get_option('whosamung_method')=="cURL"){
	$content = url2($url); 
} else if (get_option('whosamung_method')=="PHP") {
	$content = file_get_contents($url);	
}
$wp_admin_bar->add_menu( array( 'id' => 'codex_search', 
								'title' => '<script src="http://code.jquery.com/jquery-latest.js"></script>
<script>
 $(document).ready(function() {
		$("#whos_stats").load("index.php?page=whosamung-stats #whos_stats");
   var refreshId = setInterval(function() {
		$("#whos_stats").load("index.php?page=whosamung-stats #whos_stats");
   }, 20000);
   $.ajaxSetup({ cache: false });
});
</script>
<div id="whos_stats" style="float:right;"><img src="'.$x.'/favicon.png"> '. __("Actual users Online:", 'wp-whos-amung') . $content .'</div>', 'textdomain' , 
								'href' => 'http://whos.amung.us/stats/'. get_option('whosamung_id') .'/' ,
								'meta' => array( 'target' => '_blank', 'title' => __("Whos Amung Live Stats") )
								
								));
}
add_action( 'admin_bar_menu', 'wp_codex_search_form', 1000 );

//settings
add_action( 'admin_init', 'regi_mysettings' );
function regi_mysettings() {
	//register our settings
	register_setting( 'whosamung_settings', 'whosamung_id' );
	register_setting( 'whosamung_settings', 'whosamung_method' );
}

//message
function whos_msg_error() {
	if((get_option('whosamung_id') == '')||(get_option('whosamung_method') == ''))
	echo '<div class="error"><p><strong>'. __("You should configure your Whos Amung Plugin", 'wp-whos-amung').' <a href="options-general.php?page=whosamung-config">'. __(" here", 'wp-whos-amung').'</a>.</strong></p></div>';
}
add_action( 'admin_notices', 'whos_msg_error' );

//Menus
add_action('admin_menu', 'my_plugin_menu');
function my_plugin_menu() {
	add_options_page('Whos Amung', 'Whos Amung', 'manage_options', 'whosamung-config', 'my_plugin_options');
}
function my_plugin_options() {
	if (!current_user_can('manage_options'))  {
		wp_die( __('You do not have sufficient permissions to access this page.') );
} 
?>
<style type="text/css">
/* The hint to Hide and Show */
.hint {
   	display: none;
    position: absolute;

    width: 300px;
    margin-top: -4px;
    border: 1px solid #c93;
    padding: 10px 12px;
    /* to fix IE6, I can't just declare a background-color,
    I must do a bg image, too!  So I'm duplicating the pointer.gif
    image, and positioning it so that it doesn't show up
    within the box */
    background: #ffc no-repeat -10px 5px;
}
</style>
<script type="text/javascript">
function addLoadEvent(func) {
  var oldonload = window.onload;
  if (typeof window.onload != 'function') {
    window.onload = func;
  } else {
    window.onload = function() {
      oldonload();
      func();
    }
  }
}

function prepareInputsForHints() {
	var inputs = document.getElementsByTagName("input");
	for (var i=0; i<inputs.length; i++){
		// test to see if the hint span exists first
		if (inputs[i].parentNode.getElementsByTagName("span")[0]) {
			// the span exists!  on focus, show the hint
			inputs[i].onfocus = function () {
				this.parentNode.getElementsByTagName("span")[0].style.display = "inline";
			}
			// when the cursor moves away from the field, hide the hint
			inputs[i].onblur = function () {
				this.parentNode.getElementsByTagName("span")[0].style.display = "none";
			}
		}
	}
	// repeat the same tests as above for selects
	var selects = document.getElementsByTagName("select");
	for (var k=0; k<selects.length; k++){
		if (selects[k].parentNode.getElementsByTagName("span")[0]) {
			selects[k].onfocus = function () {
				this.parentNode.getElementsByTagName("span")[0].style.display = "inline";
			}
			selects[k].onblur = function () {
				this.parentNode.getElementsByTagName("span")[0].style.display = "none";
			}
		}
	}
}
addLoadEvent(prepareInputsForHints);
</script>
<div class="wrap"><h2><div id="icon-options-general" class="icon32"></div>Whos Amung Stats - <?php _e("Configuration", 'wp-whos-amung'); ?></h2><br>
<div id="message" class="updated">
<p><?php _e("Now you can translate this plugin to your language. Take a look", 'wp-whos-amung'); ?> <a href="<?php echo $x = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__));?>lang/howto.txt" target="_blank"><?php _e("here", 'wp-whos-amung'); ?></a>. </p>
</div>
<?php if ($_GET['updated']==true) { ?>
    <br><div id="message" class="updated">
        <p>
        <?php _e("Updated.", 'wp-whos-amung'); ?>
        </p> <?php } ?>
    </div>
    <form method="post" action="options.php">
    <?php settings_fields( 'whosamung_settings' ); ?>
    <table class="form-table">
        <tr valign="top">
        <th scope="row">Whos Amung ID</th>
        <td><input type="text" name="whosamung_id" size="40" value="<?php echo get_option('whosamung_id'); ?>" /> <br /><br />
        <span class="hint"><strong><?php _e("How I find my ID?", 'wp-whos-amung'); ?></strong><br /> <?php _e("You find your ID in the stats page URL:", 'wp-whos-amung'); ?> http://whos.amung.us/stats/<em><strong>xxxxxxxxxxxx</strong></em>/ <br /> <?php _e("The", 'wp-whos-amung'); ?> <em><strong>xxxxxxxxxxxx</strong></em> <?php _e("should be replaced by your ID.", 'wp-whos-amung');?><span class="hint-pointer">&nbsp;</span></span>
</td>
        </tr>
        <tr valign="top">
        <th scope="row"><?php _e("Method", 'wp-whos-amung'); ?></th>
        <td><select name="whosamung_method" id="whosamung_method">
        	<option <?php if (get_option('whosamung_method')=="") {echo("selected");} ?>>&nbsp;</option>
            <option value="cURL" <?php if (get_option('whosamung_method')=="cURL") {echo("selected");} ?> >cURL <?php _e("(should be enabled)", 'wp-whos-amung'); ?></option>
            <option value="PHP" <?php if (get_option('whosamung_method')=="PHP") {echo("selected");} ?>>PHP <?php _e("(default)", 'wp-whos-amung'); ?></option>
        </select><br /><br /><br />
        <span class="hint"><?php _e("If Default (PHP) method doesn't work, please use cURL method if it's available on your web server.", 'wp-whos-amung'); ?></span>
        </tr>
    </table>
<br /><br /><br />
    <p class="submit">
    <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
    </p>
</form>
<?php }
?>